<?php
/*
Plugin Name: Copyrights
Version: Alpha
Description: Create copyrights and assign them to your photos.
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=537
Author: Matty & Johan (dwo)
Author URI: http://www.watergallery.nl/piwigo/plugins/copyrights/
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

define('COPYRIGHTS_PATH',
    PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)) . '/'); // The plugin path
define('COPYRIGHTS_WEB_PATH', get_root_url().'admin.php?page=plugin-copyrights');

global $prefixeTable;
define('COPYRIGHTS_ADMIN', $prefixeTable.'copyrights_admin'); // The db
define('COPYRIGHTS_MEDIA', $prefixeTable.'copyrights_media'); // The db

include_once(COPYRIGHTS_PATH . 'include/functions.inc.php');

/* Plugin admin */
add_event_handler('get_admin_plugin_menu_links', 'copyrights_admin_menu');
function copyrights_admin_menu($menu) {
  array_push(
    $menu,
    array(
      'NAME'  => 'Copyrights',
      'URL'   => get_admin_plugin_menu_link(dirname(__FILE__)).'/admin.php'
    )
  );      
  return $menu;
}

// Add copyrights drop down menu to the batch manager
add_event_handler('loc_end_element_set_global', 'copyrights_batch');
// Add handler to the submit event of the batch manager
add_event_handler('element_set_global_action', 'copyrights_batch_submit', 50, 2);

function copyrights_batch()
{
  global $template;

  //load_language('plugin.lang', dirname(__FILE__).'/');					// Engels is voorlopig goed zat

  // Assign the template for batch management
  $template->set_filename('batch', dirname(__FILE__).'/batch.tpl');

  // Fetch all the copyrights and assign them to the template
  $query = '
    SELECT `cr_id`,`name`
    FROM '.COPYRIGHTS_ADMIN.'
    WHERE `visible`<>0
    ;';
  $result = pwg_query($query);
  $CRoptions = array();
  while ($row = pwg_db_fetch_assoc($result)) {
    $CRoptions[$row['cr_id']] = $row['name'];
  }
  $template->assign('CRoptions', $CRoptions);

  
  // Goed, ik weet dus echt niet waarom dit hieronder gedaan wordt...
  // AHA!!!! - dit is er zodat de "choose action" optie deze plugin gebruikt....
  $template->append('element_set_global_plugins_actions', array(
    'ID' => 'copyrights',	// ID of the batch manager action
    'NAME' => 'Edit copyrights', // Description of the batch manager action
    'CONTENT' => $template->parse('batch', true)
    )
  );
}

// * Deze functie wordt een keer aangeroepen, nadat de gebruiker submit.
// * Fietst met een foreach loop over de geselecteerde fotos
// * Rammelt alle toevoegingen in 1x met mass_updates naar de db.
function copyrights_batch_submit($action, $collection)
{
  if ($action == 'copyrights')
  {
	  $crID = $_POST['copyrightID'];
    
    if (count($collection) > 0) {
      $query = '
        DELETE
        FROM '.COPYRIGHTS_MEDIA.'
        WHERE media_id IN ('.implode(',', $collection).')
        ;';
      pwg_query($query);
    }

    $edits = array();
    foreach ($collection as $image_id)
    {
      array_push(
        $edits,
        array(
          'media_id' => $image_id,
          'cr_id' => $crID,
          )
        );
    }

    mass_inserts(
      COPYRIGHTS_MEDIA, // Table name
      array_keys($edits[0]), //Columns
      $edits // Data
    );
  }
}

?>
